/* initialize connection to server, get its Desktop-service and XComponentLoader interface */
xMsf=ooo.connect()   -- connect to server and retrieve remote multi server factory

-- Retrieve the Desktop object, we need its XComponentLoader interface
-- to load a new document
oDesktop         = xMsf~createInstance("com.sun.star.frame.Desktop")
xDesktop         = oDesktop~XDesktop          -- get desktop interface
xComponentLoader = xDesktop~XComponentLoader  -- get componentLoader interface

-- ---------- End of connection header ---------------

-- Open the "simpress" application
propertyValueClass = .bsf4rexx~Class.class~forName("com.sun.star.beans.PropertyValue")
pPropValues = .bsf~bsf.createArray(propertyValueClass, 1)

pPropValues[1] = .bsf~new("com.sun.star.beans.PropertyValue")
pPropValues[1]~Name  = "Silent"
pPropValues[1]~Value = box("bool", .true)  -- .bsf~new("java.lang.Boolean", true))

oDrawComponent = xComponentLoader~loadComponentFromURL("private:factory/simpress", "_blank", 0, pPropValues)

-- Create three presentation pages
xDrawPagesSupplier=oDrawComponent~XDrawPagesSupplier
oDrawPages = xDrawPagesSupplier~getDrawPages

do 3
	oDrawPages~insertNewByIndex(0)
end

-- Set the slide transition for the first page
xPage=oDrawPages~getByIndex(0) ~XDrawPage
xShapes=xPage~XShapes

-- Set slide transition effect
fade=.bsf~bsf.getStaticValue("com.sun.star.presentation.FadeEffect", "FADE_FROM_RIGHT")
fast=.bsf~bsf.getStaticValue("com.sun.star.presentation.AnimationSpeed", "FAST")
call setSlideTransition xPage, fade, fast, 1, 0
	-- automatic object and slide transition

-- Create a rectangle that is placed on the top left of the page
point = .bsf~new("com.sun.star.awt.Point", 1000, 1000)
size = .bsf~new("com.sun.star.awt.Size", 5000, 5000)
xShapePropSet = createAndInsertShape(oDrawComponent, xShapes, point, size, "com.sun.star.drawing.RectangleShape")
line=.bsf~bsf.getStaticValue("com.sun.star.presentation.AnimationEffect", "WAVYLINE_FROM_BOTTOM")
xShapePropSet~setPropertyValue("Effect", line)

-- The following three properties provoke that the shape is dimmed to red
-- after the animation has been finished
xShapePropSet~setPropertyValue("DimHide",     box("Bool", .false))      -- .bsf~new("java.lang.Boolean", false))
xShapePropSet~setPropertyValue("DimPrevious", box("Bool", .true))       -- .bsf~new("java.lang.Boolean", true))
xShapePropSet~setPropertyValue("DimColor",    box("Integer", 16711680))

-- Set the slide transition for the second page
xShapes=oDrawPages~getByIndex(1) ~XShapes

-- slow = bsf("getStaticValue", "com.sun.star.presentation.AnimationSpeed", "SLOW")
slow = .bsf~bsf.getStaticValue("com.sun.star.presentation.AnimationSpeed", "SLOW")
call setSlideTransition xPage, fade, slow, 1, 0
	-- automatic object and slide transition

-- Create an ellipse that is placed on the bottom right of second page
point = .bsf~new("com.sun.star.awt.Point", 21000, 15000)
xShapePropSet = createAndInsertShape(oDrawComponent, xShapes, point, size, "com.sun.star.drawing.EllipseShape")
hide = bsf("getStaticValue", "com.sun.star.presentation.AnimationEffect", "HIDE")
xShapePropSet~setPropertyValue("Effect", hide)

-- Create two objects for the third page:
-- Clicking the first object lets the presentation jump
-- to page one by using ClickAction.FIRSTPAGE,
-- the second object lets the presentation jump to page two
-- by using a ClickAction.BOOKMARK.
xShapes=oDrawPages~getByIndex(2) ~xShapes

roll = .bsf~bsf.getStaticValue("com.sun.star.presentation.FadeEffect", "ROLL_FROM_LEFT")
medium = .bsf~bsf.getStaticValue("com.sun.star.presentation.AnimationSpeed", "MEDIUM")
call setSlideTransition xPage, roll, medium, 2, 0
point = .bsf~new("com.sun.star.awt.Point", 1000, 8000)
xShape = createShape(oDrawComponent, point, size, "com.sun.star.drawing.EllipseShape")

xShapes~add(xShape)
call addPortion xShape, "click to go", 0
call addPortion xShape, "to first page", 1

xShapePropSet=xShape~XPropertySet

fadebottom = .bsf~bsf.getStaticValue("com.sun.star.presentation.AnimationEffect", "FADE_FROM_BOTTOM")
xShapePropSet~setPropertyValue("Effect", fadebottom)

firstpage = .bsf~bsf.getStaticValue("com.sun.star.presentation.ClickAction", "FIRSTPAGE")
xShapePropSet~setPropertyValue("OnClick", firstpage)
point = .bsf~new("com.sun.star.awt.Point", 22000, 8000)
xShape = createShape(oDrawComponent, point, size, "com.sun.star.drawing.RectangleShape")

xShapes~add(xShape)
call addPortion xShape, "click to go", 0
call addPortion xShape, "to the second page", 1

xShapePropSet=xShape~XPropertySet
xShapePropSet~setPropertyValue("Effect", fadebottom)

-- bookmark = bsf("getStaticValue", "com.sun.star.presentation.ClickAction", "BOOKMARK")
bookmark = .bsf~bsf.getStaticValue("com.sun.star.presentation.ClickAction", "BOOKMARK")
xShapePropSet~setPropertyValue("OnClick", bookmark)

-- Set the name of page two, and use it with the bookmark action
xPageName=oDrawPages~getByIndex(1)~XNamed

xPageName~setName("page two")
xShapePropSet~bsf.invokeStrict("setPropertyValue", "ST", "Bookmark", "ST", xPageName~getName)

-- Start an endless presentation which is displayed in
-- full-screen mode and placed on top
xPresSupplier=oDrawComponent~XPresentationSupplier

xPresentation = xPresSupplier~getPresentation
xPresPropSet=xPresentation~XPropertySet

xPresPropSet~setPropertyValue("IsEndless",     box("bo", .true)) -- .bsf~new("java.lang.Boolean", true))
xPresPropSet~setPropertyValue("IsAlwaysOnTop", box("bo", .true)) -- .bsf~new("java.lang.Boolean", true))
xPresPropSet~setPropertyValue("Pause",         box("int", 0))    -- .bsf~new("java.lang.Integer", 0))
xPresentation~bsf.invoke("start")   -- "START" is a method in ooRexx "Object", hence pass-thru needed!

EXIT

::requires OOO.CLS   -- ooRexx support for OpenOffice.org
-- Auxiliary functions used in the example: ------------------------------

-- This simple method applies the slide transition to a page
::routine setSlideTransition
   use arg xPage, eEffect, eSpeed, nChange, nDuration

	-- The following test is only sensible if you do not exactly know
	-- what type of page xPage is, for this purpose it can been tested
	-- if the com.sun.star.presentation.DrawPage service is supported
	-- xServiceInfoName = .bsf4rexx~Class.class~forName("com.sun.star.lang.XServiceInfo")
	-- xInfo = unoRuntime~queryInterface(xServiceInfoName, xPage)

   xInfo=xPage~XServiceInfo

	if xInfo~supportsService("com.sun.star.presentation.DrawPage") then
	do
      xPropSet=xPage~XPropertySet

		xPropSet~setPropertyValue("Effect",  eEffect)
		xPropSet~setPropertyValue("Speed",   eSpeed)
		xPropSet~setPropertyValue("Change",  box("int", nChange))   --  .bsf~new("java.lang.Integer", nChange))
		xPropSet~setPropertyValue("Duration",box("int", nDuration)) --  .bsf~new("java.lang.Integer", nDuration))
	end
	RETURN

::routine createAndInsertShape
   use arg xDrawDoc, xShapes, aPos, aSize, sShapeType

	xShape = createShape(xDrawDoc, aPos, aSize, sShapeType)
	xShapes~add(xShape)
   xPropSet=xShape~XPropertySet
	RETURN xPropSet

::routine createShape
   use arg xDrawDoc, aPos, aSize, sShapeType

   xFactory=xDrawDoc~XMultiServiceFactory
	xShape = xFactory~createInstance(sShapeType) ~XShape

	xShape~setPosition(aPos)
	xShape~setSize(aSize)

	RETURN xShape

::routine addPortion
   use arg xShape, sText, bNewParagraph

   xText=xShape~XText

	xTextCursor = xText~createTextCursor
	xTextCursor~gotoEnd(.false)
	if bNewParagraph = 1 then
	do
		pbreak = .bsf~bsf.getStaticValue("com.sun.star.text.ControlCharacter", "PARAGRAPH_BREAK")
		xText~insertControlCharacter(xTextCursor, pbreak, .false)
		xTextCursor~gotoEnd(.false)
	end

   xTextRange=xTextCursor~XTextRange
	xTextRange~setString(sText)
	xTextCursor~gotoEnd(.true)
   xPropSet=xTextRange~XPropertySet

	RETURN xPropSet


